package org.bitbucket.openisoj;

import java.util.HashMap;

import org.bitbucket.openisoj.formatter.Formatters;
import org.bitbucket.openisoj.formatter.IFormatter;

public class Template extends HashMap<Integer, IFieldDescriptor>
{
	/**
	 * 
	 */
	private static final long	serialVersionUID	= 1L;

	private IFormatter			_msgTypeFormatter;

	public Template()
	{
		setMsgTypeFormatter(Formatters.getAscii());
	}

	public String describePacking() throws Exception
	{
		StringBuilder sb = new StringBuilder();

		for (java.util.Map.Entry<Integer, IFieldDescriptor> entry : entrySet())
		{
			int field = entry.getKey();
			IFieldDescriptor descriptor = entry.getValue();
			sb.append(descriptor.display("", field, null));
		}

		return sb.toString();
	}

	public IFormatter getMsgTypeFormatter()
	{
		return _msgTypeFormatter;
	}

	public void setMsgTypeFormatter(IFormatter _msgTypeFormatter)
	{
		this._msgTypeFormatter = _msgTypeFormatter;
	}
}
